#
# Makefile for utils for Atari TOS gcc
# - adjust CROSSDIR below for your setup if cross compiling otherwise
#   adjust CC
#
#
CROSSDIR = /dsrg/bammi/cross-gcc
CROSSBIN = $(CROSSDIR)/bin
CROSSLIB = $(CROSSDIR)/lib
CROSSINC = $(CROSSDIR)/include

# Cross GCC
CC=$(CROSSBIN)/cgcc

CFLAGS = -O -Datarist -I.

all: ld sym-ld nm ar size size68 cnm

#
# the 'regular' linker, produces atari executables
#
ld : ld.o
	$(CC) -o ld ld.o

#
# the 'other' linker, produdes atari gdb compat symb files
#
sym-ld : sym-ld.o
	$(CC) -o sym-ld sym-ld.o

#
# symbol lister (NaMe list) gnu format only -- ie .o's and .olb's only
#
nm : nm.o
	$(CC) -o nm nm.o

# 
# Object file sizes (gnu format only) -- .o's and .olb's only
#
size: size.o
	$(CC) -o size size.o

#
# ar - archiver/librarian
#
ar : ar.o
	$(CC) -o ar ar.o

#
# show sizes of tos format executable
#
size68: size68.c
	$(CC) -O -o size68 size68.c -s

#
# show symbols of tos format executable
# absolute minimal functionality.
#
cnm: cnm.c
	$(CC) -O -o cnm cnm.c

clean:
	rm -f *.o core
